//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
#property copyright "www.forex-tsd.com"
#property link      "www.forex-tsd.com"

#property indicator_separate_window
#property indicator_buffers 4
#property indicator_color1  DimGray
#property indicator_color2  Gray
#property indicator_color3  Red
#property indicator_color4  LimeGreen
#property indicator_width2  2
#property indicator_width3  2
#property indicator_width4  2
#property indicator_style1  STYLE_DOT
#property indicator_level1  0

//
//
//
//
//

extern string TimeFrame           = "Current time frame";
extern int    SSPeriod            =  14;
extern int    topLine             =  100;
extern int    bottomLine          = -100;
extern bool   showTopBottomLevels = true;
extern bool   showSignals         = true;

//
//
//
//
//

double ttf[];
double lev[];
double sigu[];
double sigd[];
double trend[];
double trends[];

//
//
//
//
//

string indicatorFileName;
bool   returnBars;
bool   calculateValue;
int    timeFrame;

//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
//
//
//
//
//

int init()
{
   IndicatorBuffers(6);
      SetIndexBuffer(0,lev);
      SetIndexBuffer(1,ttf);
      SetIndexBuffer(2,sigu); SetIndexStyle(2,DRAW_ARROW); SetIndexArrow(2,159);
      SetIndexBuffer(3,sigd); SetIndexStyle(3,DRAW_ARROW); SetIndexArrow(3,159);
      SetIndexBuffer(4,trend);
      SetIndexBuffer(5,trends);
      
      //
      //
      //
      //
      //
   
        indicatorFileName = WindowExpertName();
        returnBars        = (TimeFrame == "returnBars");     if (returnBars)     return(0);
        calculateValue    = (TimeFrame == "calculateValue"); if (calculateValue) return(0);
        timeFrame         = stringToTimeFrame(TimeFrame);   

     //
     //
     //
     //
     //
   
    IndicatorShortName(timeFrameToString(timeFrame)+" Super smoother TTF");           
    return(0);
}

//+------------------------------------------------------------------
//|
//+------------------------------------------------------------------
//
//
//
//
//

int start()
{
   int limit,counted_bars=IndicatorCounted();
      if(counted_bars<0) return(-1);
      if(counted_bars>0) counted_bars--;
         limit = MathMin(Bars-counted_bars,Bars-1);
         if (returnBars) { lev[0] = limit+1; return(0); }

   //
   //
   //
   //
   //
   
   if (calculateValue || timeFrame == Period())
   {
   
   for(int i=limit; i >= 0; i--)
   {
      double HighestHighRecent = High[iHighest(NULL,0,MODE_HIGH,SSPeriod,i)];
      double HighestHighOlder  = High[iHighest(NULL,0,MODE_HIGH,SSPeriod,i+SSPeriod)];
      double LowestLowRecent   =  Low[iLowest(NULL, 0,MODE_LOW, SSPeriod,i)];
      double LowestLowOlder    =  Low[iLowest(NULL, 0,MODE_LOW, SSPeriod,i+SSPeriod)];
      
         double BuyPower  = HighestHighRecent - LowestLowOlder;
         double SellPower = HighestHighOlder  - LowestLowRecent;
               ttf[i] = iSsm((BuyPower-SellPower)/(0.5*(BuyPower+SellPower))*100.0,SSPeriod,i,0);
      
      //
      //
      //
      //
      //
         
      if (showTopBottomLevels)
      {
         trend[i] = trend[i+1];
            if (ttf[i] > 0) trend[i] =  1;
            if (ttf[i] < 0) trend[i] = -1;
            if (trend[i]== 1) lev[i] = topLine;
            if (trend[i]==-1) lev[i] = bottomLine;
      }
      
      if (showSignals)
      {
         sigu[i] = EMPTY_VALUE;
         sigd[i] = EMPTY_VALUE;
         trends[i] = 0;
            if (ttf[i] > topLine)    trends[i] =  1;
            if (ttf[i] < bottomLine) trends[i] = -1;
            if (trends[i]== 1) sigu[i] = topLine;
            if (trends[i]==-1) sigd[i] = bottomLine;
      }
   }
   return(0);
   }

   //
   //
   //
   //
   //       
    
   limit = MathMax(limit,MathMin(Bars-1,iCustom(NULL,timeFrame,indicatorFileName,"returnBars",0,0)*timeFrame/Period())); 
   for(i=limit; i>=0; i--)
   {
      int y = iBarShift(NULL,timeFrame,Time[i]);
         lev[i]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",SSPeriod,topLine,bottomLine,showTopBottomLevels,showSignals,0,y);
         ttf[i]    = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",SSPeriod,topLine,bottomLine,showTopBottomLevels,showSignals,1,y);
         sigu[i]   = EMPTY_VALUE;
         sigd[i]   = EMPTY_VALUE;
         trend[i]  = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",SSPeriod,topLine,bottomLine,showTopBottomLevels,showSignals,4,y);
         trends[i] = iCustom(NULL,timeFrame,indicatorFileName,"calculateValue",SSPeriod,topLine,bottomLine,showTopBottomLevels,showSignals,5,y);
         
         //
         //
         //
         //
         //
         
         if (showTopBottomLevels)
         {
            trend[i] = trend[i+1];
               if (ttf[i] > 0) trend[i] =  1;
               if (ttf[i] < 0) trend[i] = -1;
               if (trend[i]== 1) lev[i] = topLine;
               if (trend[i]==-1) lev[i] = bottomLine;
         }
      
         if (showSignals)
         {
            trends[i] = 0;
               if (ttf[i] > topLine)    trends[i] =  1;
               if (ttf[i] < bottomLine) trends[i] = -1;
               if (trends[i]== 1) sigu[i] = topLine;
               if (trends[i]==-1) sigd[i] = bottomLine;
         }
   }
   return(0);
   }

//
//
//
//
//

double workSsm[][2];
#define _price  0
#define _ssm    1

double workSsmCoeffs[][4];
#define _period 0
#define _c1     1
#define _c2     2
#define _c3     3
#define Pi 3.14159265358979323846264338327950288

//
//
//
//
//

double iSsm(double price, double period, int i, int instanceNo)
{
   if (ArrayRange(workSsm,0) !=Bars)                 ArrayResize(workSsm,Bars);
   if (ArrayRange(workSsmCoeffs,0) < (instanceNo+1)) ArrayResize(workSsmCoeffs,instanceNo+1);
   if (workSsmCoeffs[instanceNo][_period] != period)
   {
      workSsmCoeffs[instanceNo][_period] = period;
      double a1 = MathExp(-1.414*Pi/period);
      double b1 = 2.0*a1*MathCos(1.414*Pi/period);
         workSsmCoeffs[instanceNo][_c2] = b1;
         workSsmCoeffs[instanceNo][_c3] = -a1*a1;
         workSsmCoeffs[instanceNo][_c1] = 1.0 - workSsmCoeffs[instanceNo][_c2] - workSsmCoeffs[instanceNo][_c3];
   }

   //
   //
   //
   //
   //

      i = Bars-i-1;
      int s = instanceNo*2;   
          workSsm[i][s+_price] = price;
          workSsm[i][s+_ssm]   = workSsmCoeffs[instanceNo][_c1]*(workSsm[i][s+_price]+workSsm[i-1][s+_price])/2.0 + 
                                 workSsmCoeffs[instanceNo][_c2]*workSsm[i-1][s+_ssm]                              + 
                                 workSsmCoeffs[instanceNo][_c3]*workSsm[i-2][s+_ssm];
   return(workSsm[i][s+_ssm]);
} 

//+------------------------------------------------------------------
//|                                                                  
//+------------------------------------------------------------------
// 
//
//
//
//

string sTfTable[] = {"M1","M5","M15","M30","H1","H4","D1","W1","MN"};
int    iTfTable[] = {1,5,15,30,60,240,1440,10080,43200};

//
//
//
//
//

int stringToTimeFrame(string tfs)
{
   tfs = StringUpperCase(tfs);
   for (int i=ArraySize(iTfTable)-1; i>=0; i--)
         if (tfs==sTfTable[i] || tfs==""+iTfTable[i]) return(MathMax(iTfTable[i],Period()));
                                                      return(Period());
}

//
//
//
//
//

string timeFrameToString(int tf)
{
   for (int i=ArraySize(iTfTable)-1; i>=0; i--) 
         if (tf==iTfTable[i]) return(sTfTable[i]);
                              return("");
}

//
//
//
//
//

string StringUpperCase(string str)
{
   string   s = str;

   for (int length=StringLen(str)-1; length>=0; length--)
   {
      int tchar = StringGetChar(s, length);
         if((tchar > 96 && tchar < 123) || (tchar > 223 && tchar < 256))
                     s = StringSetChar(s, length, tchar - 32);
         else if(tchar > -33 && tchar < 0)
                     s = StringSetChar(s, length, tchar + 224);
   }
   return(s);
}


